Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.cs	(revision 2027)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.cs	(revision 2027)
@@ -0,0 +1,172 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Text;
+using System.Windows.Forms;
+
+namespace HeuristicLab.Core {
+  /// <summary>
+  /// The visual representation of the information of the variables of an operator.
+  /// </summary>
+  public partial class OperatorBaseParametersView : ViewBase {
+    /// <summary>
+    /// Gets or sets the operator whose variable infos should be represented visually.
+    /// </summary>
+    /// <remarks>Uses property <see cref="ViewBase.Item"/> of base class <see cref="ViewBase"/>.
+    /// No own data storage present.</remarks>
+    public IOperator Operator {
+      get { return (IOperator)Item; }
+      set { base.Item = value; }
+    }
+    /// <summary>
+    /// Gets all selected variable infos.
+    /// <note type="caution"> Variable infos are returned read-only!</note>
+    /// </summary>
+    public ICollection<IParameter> SelectedParameter {
+      get {
+        List<IParameter> selected = new List<IParameter>();
+        foreach (ListViewItem item in parametersListView.SelectedItems)
+          selected.Add((IParameter)item.Tag);
+        return selected.AsReadOnly();
+      }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorBaseVariableInfosView"/> with caption "Operator".
+    /// </summary>
+    public OperatorBaseParametersView() {
+      InitializeComponent();
+      parametersListView.Columns[0].Width = Math.Max(0, parametersListView.Width - 25);
+      Caption = "Operator";
+    }
+    /// <summary>
+    /// Initializes a new instance of <see cref="OperatorBaseVariableInfosView"/> with the given operator
+    /// <paramref name="op"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="OperatorBaseVariableInfosView()"/>.</remarks>
+    /// <param name="op">The operator whose variable infos should be displayed.</param>
+    public OperatorBaseParametersView(IOperator op)
+      : this() {
+      Operator = op;
+    }
+
+    /// <summary>
+    /// Removes the eventhandlers from the underlying <see cref="IOperator"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.RemoveItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
+    protected override void RemoveItemEvents() {
+      Operator.ParameterAdded -= new EventHandler<ParameterEventArgs>(OperatorBase_ParameterAdded);
+      Operator.ParameterRemoved -= new EventHandler<ParameterEventArgs>(OperatorBase_ParameterRemoved);
+      base.RemoveItemEvents();
+    }
+    /// <summary>
+    /// Adds eventhandlers to the underlying <see cref="IOperator"/>.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.AddItemEvents"/> of base class <see cref="ViewBase"/>.</remarks>
+    protected override void AddItemEvents() {
+      base.AddItemEvents();
+      Operator.ParameterAdded += new EventHandler<ParameterEventArgs>(OperatorBase_ParameterAdded);
+      Operator.ParameterRemoved += new EventHandler<ParameterEventArgs>(OperatorBase_ParameterRemoved);
+    }
+
+    /// <summary>
+    /// Updates all controls with the latest data of the model.
+    /// </summary>
+    /// <remarks>Calls <see cref="ViewBase.UpdateControls"/> of base class <see cref="ViewBase"/>.</remarks>
+    protected override void UpdateControls() {
+      base.UpdateControls();
+      parameterDetailsGroupBox.Controls.Clear();
+      if (Operator == null) {
+        Caption = "Operator";
+        parametersListView.Enabled = false;
+        parameterDetailsGroupBox.Enabled = false;
+      } else {
+        Caption = Operator.Name + " (" + Operator.GetType().Name + ")";
+        parametersListView.Enabled = true;
+        parametersListView.Items.Clear();
+        foreach (IParameter parameter in Operator.Parameters) {
+          ListViewItem item = new ListViewItem();
+          item.Text = parameter.Name;
+          item.Tag = parameter;
+          parametersListView.Items.Add(item);
+        }
+        if (parametersListView.Items.Count > 0)
+          parametersListView.SelectedIndices.Add(0);
+      }
+    }
+
+    private void parametersListView_SelectedIndexChanged(object sender, EventArgs e) {
+      if (parameterDetailsGroupBox.Controls.Count > 0)
+        parameterDetailsGroupBox.Controls[0].Dispose();
+      parameterDetailsGroupBox.Controls.Clear();
+      parameterDetailsGroupBox.Enabled = false;
+      if (parametersListView.SelectedItems.Count == 1) {
+        IParameter parameter = (IParameter)parametersListView.SelectedItems[0].Tag;
+        Control control = (Control)parameter.CreateView();
+        parameterDetailsGroupBox.Controls.Add(control);
+        control.Dock = DockStyle.Fill;
+        parameterDetailsGroupBox.Enabled = true;
+      }
+      OnSelectedParametersChanged();
+    }
+
+    /// <summary>
+    /// Occurs when the variables were changed, whose infos should be displayed.
+    /// </summary>
+    public event EventHandler SelectedParametersChanged;
+    /// <summary>
+    /// Fires a new <c>SelectedVariableInfosChanged</c>.
+    /// </summary>
+    protected virtual void OnSelectedParametersChanged() {
+      if (SelectedParametersChanged != null)
+        SelectedParametersChanged(this, new EventArgs());
+    }
+
+    #region Size Changed Events
+    private void parametersListView_SizeChanged(object sender, EventArgs e) {
+      if (parametersListView.Columns.Count > 0)
+        parametersListView.Columns[0].Width = Math.Max(0, parametersListView.Width - 25);
+    }
+    #endregion
+
+    #region OperatorBase Events
+    private void OperatorBase_ParameterAdded(object sender, ParameterEventArgs e) {
+      ListViewItem item = new ListViewItem();
+      item.Text = e.Parameter.Name;
+      item.Tag = e.Parameter;
+      parametersListView.Items.Add(item);
+    }
+    private void OperatorBase_ParameterRemoved(object sender, ParameterEventArgs e) {
+      ListViewItem itemToDelete = null;
+      foreach (ListViewItem item in parametersListView.Items) {
+        if (item.Tag == e.Parameter)
+          itemToDelete = item;
+      }
+      parametersListView.Items.Remove(itemToDelete);
+    }
+    #endregion
+  }
+}
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.resx
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.resx	(revision 2027)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseParametersView.resx	(revision 2027)
@@ -0,0 +1,120 @@
+<?xml version="1.0" encoding="utf-8"?>
+<root>
+  <!-- 
+    Microsoft ResX Schema 
+    
+    Version 2.0
+    
+    The primary goals of this format is to allow a simple XML format 
+    that is mostly human readable. The generation and parsing of the 
+    various data types are done through the TypeConverter classes 
+    associated with the data types.
+    
+    Example:
+    
+    ... ado.net/XML headers & schema ...
+    <resheader name="resmimetype">text/microsoft-resx</resheader>
+    <resheader name="version">2.0</resheader>
+    <resheader name="reader">System.Resources.ResXResourceReader, System.Windows.Forms, ...</resheader>
+    <resheader name="writer">System.Resources.ResXResourceWriter, System.Windows.Forms, ...</resheader>
+    <data name="Name1"><value>this is my long string</value><comment>this is a comment</comment></data>
+    <data name="Color1" type="System.Drawing.Color, System.Drawing">Blue</data>
+    <data name="Bitmap1" mimetype="application/x-microsoft.net.object.binary.base64">
+        <value>[base64 mime encoded serialized .NET Framework object]</value>
+    </data>
+    <data name="Icon1" type="System.Drawing.Icon, System.Drawing" mimetype="application/x-microsoft.net.object.bytearray.base64">
+        <value>[base64 mime encoded string representing a byte array form of the .NET Framework object]</value>
+        <comment>This is a comment</comment>
+    </data>
+                
+    There are any number of "resheader" rows that contain simple 
+    name/value pairs.
+    
+    Each data row contains a name, and value. The row also contains a 
+    type or mimetype. Type corresponds to a .NET class that support 
+    text/value conversion through the TypeConverter architecture. 
+    Classes that don't support this are serialized and stored with the 
+    mimetype set.
+    
+    The mimetype is used for serialized objects, and tells the 
+    ResXResourceReader how to depersist the object. This is currently not 
+    extensible. For a given mimetype the value must be set accordingly:
+    
+    Note - application/x-microsoft.net.object.binary.base64 is the format 
+    that the ResXResourceWriter will generate, however the reader can 
+    read any of the formats listed below.
+    
+    mimetype: application/x-microsoft.net.object.binary.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Binary.BinaryFormatter
+            : and then encoded with base64 encoding.
+    
+    mimetype: application/x-microsoft.net.object.soap.base64
+    value   : The object must be serialized with 
+            : System.Runtime.Serialization.Formatters.Soap.SoapFormatter
+            : and then encoded with base64 encoding.
+
+    mimetype: application/x-microsoft.net.object.bytearray.base64
+    value   : The object must be serialized into a byte array 
+            : using a System.ComponentModel.TypeConverter
+            : and then encoded with base64 encoding.
+    -->
+  <xsd:schema id="root" xmlns="" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:msdata="urn:schemas-microsoft-com:xml-msdata">
+    <xsd:import namespace="http://www.w3.org/XML/1998/namespace" />
+    <xsd:element name="root" msdata:IsDataSet="true">
+      <xsd:complexType>
+        <xsd:choice maxOccurs="unbounded">
+          <xsd:element name="metadata">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" />
+              </xsd:sequence>
+              <xsd:attribute name="name" use="required" type="xsd:string" />
+              <xsd:attribute name="type" type="xsd:string" />
+              <xsd:attribute name="mimetype" type="xsd:string" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="assembly">
+            <xsd:complexType>
+              <xsd:attribute name="alias" type="xsd:string" />
+              <xsd:attribute name="name" type="xsd:string" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="data">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+                <xsd:element name="comment" type="xsd:string" minOccurs="0" msdata:Ordinal="2" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" msdata:Ordinal="1" />
+              <xsd:attribute name="type" type="xsd:string" msdata:Ordinal="3" />
+              <xsd:attribute name="mimetype" type="xsd:string" msdata:Ordinal="4" />
+              <xsd:attribute ref="xml:space" />
+            </xsd:complexType>
+          </xsd:element>
+          <xsd:element name="resheader">
+            <xsd:complexType>
+              <xsd:sequence>
+                <xsd:element name="value" type="xsd:string" minOccurs="0" msdata:Ordinal="1" />
+              </xsd:sequence>
+              <xsd:attribute name="name" type="xsd:string" use="required" />
+            </xsd:complexType>
+          </xsd:element>
+        </xsd:choice>
+      </xsd:complexType>
+    </xsd:element>
+  </xsd:schema>
+  <resheader name="resmimetype">
+    <value>text/microsoft-resx</value>
+  </resheader>
+  <resheader name="version">
+    <value>2.0</value>
+  </resheader>
+  <resheader name="reader">
+    <value>System.Resources.ResXResourceReader, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+  <resheader name="writer">
+    <value>System.Resources.ResXResourceWriter, System.Windows.Forms, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b77a5c561934e089</value>
+  </resheader>
+</root>
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.Designer.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.Designer.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.Designer.cs	(revision 2027)
@@ -49,16 +49,10 @@
     private void InitializeComponent() {
       this.tabControl = new System.Windows.Forms.TabControl();
-      this.variableInfosTabPage = new System.Windows.Forms.TabPage();
-      this.operatorBaseVariableInfosView = new HeuristicLab.Core.OperatorBaseVariableInfosView();
-      this.variablesTabPage = new System.Windows.Forms.TabPage();
-      this.operatorBaseVariablesView = new HeuristicLab.Core.OperatorBaseVariablesView();
-      this.constraintsTabPage = new System.Windows.Forms.TabPage();
-      this.constrainedItemBaseView = new HeuristicLab.Core.ConstrainedItemBaseView();
+      this.parametersTabPage = new System.Windows.Forms.TabPage();
+      this.operatorBaseParametersView = new HeuristicLab.Core.OperatorBaseParametersView();
       this.descriptionTabPage = new System.Windows.Forms.TabPage();
       this.operatorBaseDescriptionView = new HeuristicLab.Core.OperatorBaseDescriptionView();
       this.tabControl.SuspendLayout();
-      this.variableInfosTabPage.SuspendLayout();
-      this.variablesTabPage.SuspendLayout();
-      this.constraintsTabPage.SuspendLayout();
+      this.parametersTabPage.SuspendLayout();
       this.descriptionTabPage.SuspendLayout();
       this.SuspendLayout();
@@ -66,7 +60,5 @@
       // tabControl
       // 
-      this.tabControl.Controls.Add(this.variableInfosTabPage);
-      this.tabControl.Controls.Add(this.variablesTabPage);
-      this.tabControl.Controls.Add(this.constraintsTabPage);
+      this.tabControl.Controls.Add(this.parametersTabPage);
       this.tabControl.Controls.Add(this.descriptionTabPage);
       this.tabControl.Dock = System.Windows.Forms.DockStyle.Fill;
@@ -77,66 +69,24 @@
       this.tabControl.TabIndex = 0;
       // 
-      // variableInfosTabPage
+      // parametersTabPage
       // 
-      this.variableInfosTabPage.Controls.Add(this.operatorBaseVariableInfosView);
-      this.variableInfosTabPage.Location = new System.Drawing.Point(4, 22);
-      this.variableInfosTabPage.Name = "variableInfosTabPage";
-      this.variableInfosTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.variableInfosTabPage.Size = new System.Drawing.Size(415, 307);
-      this.variableInfosTabPage.TabIndex = 0;
-      this.variableInfosTabPage.Text = "Variable Infos";
-      this.variableInfosTabPage.UseVisualStyleBackColor = true;
+      this.parametersTabPage.Controls.Add(this.operatorBaseParametersView);
+      this.parametersTabPage.Location = new System.Drawing.Point(4, 22);
+      this.parametersTabPage.Name = "parametersTabPage";
+      this.parametersTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.parametersTabPage.Size = new System.Drawing.Size(415, 307);
+      this.parametersTabPage.TabIndex = 0;
+      this.parametersTabPage.Text = "Parameters";
+      this.parametersTabPage.UseVisualStyleBackColor = true;
       // 
       // operatorBaseVariableInfosView
       // 
-      this.operatorBaseVariableInfosView.Caption = "Operator";
-      this.operatorBaseVariableInfosView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operatorBaseVariableInfosView.Location = new System.Drawing.Point(3, 3);
-      this.operatorBaseVariableInfosView.Name = "operatorBaseVariableInfosView";
-      this.operatorBaseVariableInfosView.Operator = null;
-      this.operatorBaseVariableInfosView.Size = new System.Drawing.Size(409, 301);
-      this.operatorBaseVariableInfosView.TabIndex = 0;
-      // 
-      // variablesTabPage
-      // 
-      this.variablesTabPage.Controls.Add(this.operatorBaseVariablesView);
-      this.variablesTabPage.Location = new System.Drawing.Point(4, 22);
-      this.variablesTabPage.Name = "variablesTabPage";
-      this.variablesTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.variablesTabPage.Size = new System.Drawing.Size(415, 307);
-      this.variablesTabPage.TabIndex = 1;
-      this.variablesTabPage.Text = "Local Variables";
-      this.variablesTabPage.UseVisualStyleBackColor = true;
-      // 
-      // operatorBaseVariablesView
-      // 
-      this.operatorBaseVariablesView.Caption = "Operator";
-      this.operatorBaseVariablesView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.operatorBaseVariablesView.Location = new System.Drawing.Point(3, 3);
-      this.operatorBaseVariablesView.Name = "operatorBaseVariablesView";
-      this.operatorBaseVariablesView.Operator = null;
-      this.operatorBaseVariablesView.Size = new System.Drawing.Size(409, 301);
-      this.operatorBaseVariablesView.TabIndex = 0;
-      // 
-      // constraintsTabPage
-      // 
-      this.constraintsTabPage.Controls.Add(this.constrainedItemBaseView);
-      this.constraintsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.constraintsTabPage.Name = "constraintsTabPage";
-      this.constraintsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.constraintsTabPage.Size = new System.Drawing.Size(415, 307);
-      this.constraintsTabPage.TabIndex = 2;
-      this.constraintsTabPage.Text = "Constraints";
-      this.constraintsTabPage.UseVisualStyleBackColor = true;
-      // 
-      // constrainedItemBaseView
-      // 
-      this.constrainedItemBaseView.Caption = "Constrained Data";
-      this.constrainedItemBaseView.ConstrainedItem = null;
-      this.constrainedItemBaseView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.constrainedItemBaseView.Location = new System.Drawing.Point(3, 3);
-      this.constrainedItemBaseView.Name = "constrainedItemBaseView";
-      this.constrainedItemBaseView.Size = new System.Drawing.Size(409, 301);
-      this.constrainedItemBaseView.TabIndex = 0;
+      this.operatorBaseParametersView.Caption = "Operator";
+      this.operatorBaseParametersView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.operatorBaseParametersView.Location = new System.Drawing.Point(3, 3);
+      this.operatorBaseParametersView.Name = "operatorBaseVariableInfosView";
+      this.operatorBaseParametersView.Operator = null;
+      this.operatorBaseParametersView.Size = new System.Drawing.Size(409, 301);
+      this.operatorBaseParametersView.TabIndex = 0;
       // 
       // descriptionTabPage
@@ -170,7 +120,5 @@
       this.Size = new System.Drawing.Size(423, 333);
       this.tabControl.ResumeLayout(false);
-      this.variableInfosTabPage.ResumeLayout(false);
-      this.variablesTabPage.ResumeLayout(false);
-      this.constraintsTabPage.ResumeLayout(false);
+      this.parametersTabPage.ResumeLayout(false);
       this.descriptionTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
@@ -181,10 +129,6 @@
 
     protected TabControl tabControl;
-    protected TabPage variableInfosTabPage;
-    protected TabPage variablesTabPage;
-    private TabPage constraintsTabPage;
-    protected ConstrainedItemBaseView constrainedItemBaseView;
-    protected OperatorBaseVariableInfosView operatorBaseVariableInfosView;
-    protected OperatorBaseVariablesView operatorBaseVariablesView;
+    protected TabPage parametersTabPage;
+    protected OperatorBaseParametersView operatorBaseParametersView;
     private TabPage descriptionTabPage;
     private OperatorBaseDescriptionView operatorBaseDescriptionView;
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorBaseView.cs	(revision 2027)
@@ -66,7 +66,5 @@
     /// </summary>
     protected override void RemoveItemEvents() {
-      operatorBaseVariableInfosView.Operator = null;
-      operatorBaseVariablesView.Operator = null;
-      constrainedItemBaseView.ConstrainedItem = null;
+      operatorBaseParametersView.Operator = null;
       operatorBaseDescriptionView.Operator = null;
       base.RemoveItemEvents();
@@ -77,7 +75,5 @@
     protected override void AddItemEvents() {
       base.AddItemEvents();
-      operatorBaseVariableInfosView.Operator = Operator;
-      operatorBaseVariablesView.Operator = Operator;
-      constrainedItemBaseView.ConstrainedItem = Operator;
+      operatorBaseParametersView.Operator = Operator;
       operatorBaseDescriptionView.Operator = Operator;
     }
Index: branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorGraphView.cs
===================================================================
--- branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorGraphView.cs	(revision 1994)
+++ branches/Operator Architecture Refactoring/HeuristicLab.Core/3.2/OperatorGraphView.cs	(revision 2027)
@@ -350,37 +350,13 @@
               IOperator newParent = (IOperator)node.Parent.Tag;
               int newIndex = node.Index;
-              ICollection<IConstraint> violatedConstraints;
-              ICollection<IConstraint> violatedConstraints2;
-              oldParent.TryRemoveSubOperator(oldIndex, out violatedConstraints);
-              newParent.TryAddSubOperator(op, newIndex, out violatedConstraints2);
-              if ((violatedConstraints.Count == 0) && (violatedConstraints2.Count == 0)) {
-                graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
-              } else {
-                List<IConstraint> allViolatedConstraints = new List<IConstraint>(violatedConstraints);
-                allViolatedConstraints.AddRange(violatedConstraints2);
-                if (Auxiliary.ShowIgnoreConstraintViolationMessageBox(allViolatedConstraints) == DialogResult.Yes) {
-                  if (violatedConstraints.Count > 0)
-                    oldParent.RemoveSubOperator(oldIndex);
-                  if (violatedConstraints2.Count > 0)
-                    newParent.AddSubOperator(op, newIndex);
-                  graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
-                } else {
-                  if (violatedConstraints.Count == 0)
-                    oldParent.AddSubOperator(op, oldIndex);
-                  if (violatedConstraints2.Count == 0)
-                    newParent.RemoveSubOperator(newIndex);
-                }
-              }
+              oldParent.RemoveSubOperator(oldIndex);
+              newParent.AddSubOperator(op, newIndex);
+              graphTreeView.SelectedNode = parentNode.Nodes[newIndex];
             }
           } else {
             if (node != null) {
               IOperator parent = (IOperator)node.Tag;
-              ICollection<IConstraint> violatedConstraints;
-              if (parent.TryAddSubOperator(op, out violatedConstraints)) {
-                graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
-              } else if (Auxiliary.ShowIgnoreConstraintViolationMessageBox(violatedConstraints) == DialogResult.Yes) {
-                parent.AddSubOperator(op);
-                graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
-              }
+              parent.AddSubOperator(op);
+              graphTreeView.SelectedNode = node.Nodes[node.Nodes.Count - 1];
             }
           }
